<!-- 设备分组 - 设备信息 -->
<script lang="ts" setup name="DeviceGroupTable">
import { ElMessage, ElMessageBox } from 'element-plus'
import selectDevice from './selectDevice.vue'
import { useCheckList } from '@/utils/useCheckList'
const $props = defineProps({
  data: {
    type: Array,
    default: () => ([]),
  },
})
// 表头显示标题
const columns = ref([
  {
    text: '设备名称',
    value: 'equipmentName',
    required: true,
    isSelect: false, // 是否下拉框
  },
  {
    text: '统一编号',
    value: 'equipmentNo',
    required: false,
    isSelect: false, // 是否下拉框
  },
  {
    text: '规格型号',
    value: 'model',
    required: false,
    isSelect: false, // 是否下拉框
  },
  {
    text: '负责人',
    value: 'directorName',
    required: false,
    isSelect: false, // 是否下拉框
  },
  {
    text: '计量标识',
    value: 'meterIdentify',
    required: false,
    isSelect: false, // 是否下拉框
  },
  {
    text: '证书有效期',
    value: 'certificateValid',
    required: false,
    isSelect: true, // 是否下拉框
  },
  {
    text: '安装位置',
    value: 'installLocation',
    required: false,
    isSelect: false, // 是否下拉框
  },
])
const $route = useRoute()
const list = ref<any[]>([])
// 检查数据列表
function checkCertificateList() {
  return useCheckList(list.value, columns.value, '设备信息')
}
// 将列表置为不可编辑状态
function setAllRowReadable() {
  for (const item of list.value) {
    item.editable = false
  }
}
// 双击行显示输入框
const dblclickRow = (row: any) => {
  if ($route.path.includes('detail')) {
    return
  }
  setAllRowReadable()
  row.editable = true
}
const SelectionList = ref()
// 表格选中
const handleSelectionChange = (e: any[]) => {
  SelectionList.value = e
}
// 添加行
const addRow = () => {
  // certificateRef.value.initDialog({ title: '添加' })
  if (checkCertificateList()) {
    setAllRowReadable()
    list.value.push({
      equipmentNo: '',
      equipmentName: '',
      model: '',
      directorName: '',
      meterIdentify: '',
      certificateValid: '',
      installLocation: '',
      editable: true,
    })
  }
}
// 删除行
const removeRow = () => {
  list.value = list.value.filter((item) => {
    return !SelectionList.value.includes(item)
  })
}
// 点击设备名称输入框
const deviceRef = ref()
// 选中的行
const selectRow = ref()
const select = (text: string, index: any) => {
  if (text === '设备名称') {
    deviceRef.value.initDialog()
    selectRow.value = index
  }
}
// 选择设备
const confirm = (device: any) => {
  console.log(device, '选中的设备')
  // 判断是否重复
  if (list.value.every(item => item.equipmentId !== device.id)) {
    const row = {
      ...device,
      equipmentId: device.id,
      id: null,
      groupId: null,
    }
    list.value[selectRow.value] = row
  }
  else {
    ElMessage.warning('选择设备重复')
  }
}
const initDialog = () => {
  list.value = $props.data
}
watch(() => $props.data, (newVal) => {
  if (newVal) {
    console.log(newVal, 'newVal')
    list.value = newVal
  }
}, {
  deep: true,
  // immediate: true,
})
initDialog()
defineExpose({
  list, checkCertificateList,
})
</script>

<template>
  <detail-block-switch title="设备信息">
    <select-device ref="deviceRef" @add="confirm" />
    <template v-if="!$route.path.includes('detail')" #btns>
      <el-button type="primary">
        扫描增加
      </el-button>
      <el-button type="primary" @click="addRow">
        增加行
      </el-button>
      <el-button type="info" @click="removeRow">
        删除行
      </el-button>
    </template>
    <el-table
      ref="multipleTableRef" :data="list" style="width: 100%;" border @selection-change="handleSelectionChange"
      @row-dblclick="dblclickRow"
    >
      <el-table-column v-if="!$route.path.includes('detail')" type="selection" width="38" />
      <el-table-column align="center" label="序号" width="80" type="index" />
      <el-table-column
        v-for="item in columns" :key="item.value" :prop="item.value" :label="item.text"
        align="center"
      >
        <template #header>
          <span v-show="item.required && !$route.path.includes('detail')" style="color: red;">*</span><span>{{ item.text }}</span>
        </template>
        <template #default="scope">
          <span v-if="!scope.row.editable">{{ scope.row[item.value] }}</span>
          <el-input
            v-if="scope.row.editable && !item.isSelect && item.text === '设备名称'" v-model="scope.row[item.value]" :autofocus="true"
            :placeholder="`${item.text}`" class="input"
            @focus="select(item.text, scope.$index)"
          >
            <template #append>
              <span @click="select(item.text, scope.$index)">选择</span>
            </template>
          </el-input>
          <el-input
            v-if="scope.row.editable && !item.isSelect && item.text !== '设备名称'" v-model="scope.row[item.value]" :autofocus="true"
            :placeholder="`${item.text}`" class="input"
            @focus="select(item.text, scope.$index)"
          />
          <el-date-picker
            v-if="scope.row.editable && item.isSelect" v-model="scope.row[item.value]" type="date"
            format="YYYY-MM-DD" value-format="YYYY-MM-DD HH:mm:ss" :placeholder="`${item.text}`"
          />
        </template>
      </el-table-column>
    </el-table>
  </detail-block-switch>
</template>

<style lang="scss" scoped>
.el-dialog {
  width: 700px;
}

.el-select {
  width: 100%;
}
</style>
